import 'dart:async';
import 'dart:js' as js;

import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';
import 'package:flutter_web_plugins/flutter_web_plugins.dart';

class FlutterPlayoutPlugin {

  static void registerWith(Registrar registrar) {
    final MethodChannel channel = MethodChannel(
        "tv.mta/NativeAudioChannel",
        const StandardMethodCodec(),
        registrar.messenger);
    final FlutterPlayoutPlugin instance = FlutterPlayoutPlugin();
    channel.setMethodCallHandler(instance.handleMethodCall);
  }

  Future<dynamic> handleMethodCall(MethodCall call) async {
    debugPrint("Web Hls Plugin Is now handling the call");
    switch (call.method) {
      case 'play':
        final String url = call.arguments['url'];
        final String token = call.arguments['token'];
        js.context.callMethod("playSong",[url,token]);
        return;
      default:
        throw PlatformException(
            code: 'Unimplemented',
            details: "The url_launcher plugin for web doesn't implement "
                "the method '${call.method}'");
    }
  }


  pause() async {

  }

  stop() async {

  }

}